LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY digit_counter_10 IS
  PORT(
    clk_i       : IN  STD_LOGIC;
    rst_i       : IN  STD_LOGIC;
    tick_i      : IN  BOOLEAN;
    count_oq    : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    overflow_oq : OUT BOOLEAN);
END digit_counter_10;

ARCHITECTURE behave OF digit_counter_10 IS
  SIGNAL count_ff_q    : UNSIGNED(3 DOWNTO 0);
  SIGNAL overflow_ff_q : BOOLEAN;
BEGIN  -- behave


  PROCESS(clk_i, rst_i)
  BEGIN
    IF rst_i = '1' THEN
      count_ff_q        <= "0000";
      overflow_ff_q     <= FALSE;
    ELSIF rising_edge(clk_i) THEN
      overflow_ff_q     <= FALSE;
      IF tick_i THEN
        IF count_ff_q = "1001" THEN
          overflow_ff_q <= TRUE;
          count_ff_q    <= "0000";
        ELSE
          count_ff_q    <= count_ff_q + 1;
        END IF;
      END IF;
    END IF;
  END PROCESS;
  count_oq              <= STD_LOGIC_VECTOR(count_ff_q);
  overflow_oq           <= overflow_ff_q;
END behave;

-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY digit_counter_6 IS
  PORT(
    clk_i       : IN  STD_LOGIC;
    rst_i       : IN  STD_LOGIC;
    tick_i      : IN  BOOLEAN;
    count_oq    : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    overflow_oq : OUT BOOLEAN);
END digit_counter_6;

ARCHITECTURE behave OF digit_counter_6 IS
  SIGNAL count_ff_q    : UNSIGNED(2 DOWNTO 0);
  SIGNAL overflow_ff_q : BOOLEAN;
BEGIN  -- behave
  PROCESS(clk_i, rst_i)
  BEGIN
    IF rst_i = '1' THEN
      count_ff_q        <= "000";
      overflow_ff_q     <= FALSE;
    ELSIF rising_edge(clk_i) THEN
      overflow_ff_q     <= FALSE;
      IF tick_i THEN
        IF count_ff_q = "110" THEN
          overflow_ff_q <= TRUE;
          count_ff_q    <= "000";
        ELSE
          count_ff_q    <= count_ff_q + 1;
        END IF;
      END IF;
    END IF;
  END PROCESS;
  count_oq              <= STD_LOGIC_VECTOR(count_ff_q);
  overflow_oq           <= overflow_ff_q;
END behave;

-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY digit_counter_2 IS
  PORT(
    clk_i       : IN  STD_LOGIC;
    rst_i       : IN  STD_LOGIC;
    tick_i      : IN  BOOLEAN;
    count_oq    : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    overflow_oq : OUT BOOLEAN);
END digit_counter_2;

ARCHITECTURE behave OF digit_counter_2 IS
  SIGNAL count_ff_q    : UNSIGNED(1 DOWNTO 0);
  SIGNAL overflow_ff_q : BOOLEAN;
BEGIN  -- behave


  PROCESS(clk_i, rst_i)
  BEGIN
    IF rst_i = '1' THEN
      count_ff_q        <= "00";
      overflow_ff_q     <= FALSE;
    ELSIF rising_edge(clk_i) THEN
      overflow_ff_q     <= FALSE;
      IF tick_i THEN
        IF count_ff_q = "10" THEN
          overflow_ff_q <= TRUE;
          count_ff_q    <= "00";
        ELSE
          count_ff_q    <= count_ff_q + 1;
        END IF;
      END IF;
    END IF;
  END PROCESS;
  count_oq              <= STD_LOGIC_VECTOR(count_ff_q);
  overflow_oq           <= overflow_ff_q;
END behave;

