-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

-------------------------------------------------------------------------------

entity cpld_lcd_tb is

end cpld_lcd_tb;

-------------------------------------------------------------------------------

architecture test of cpld_lcd_tb is
  signal clk_i_i           : std_logic := '0';
  signal clk_32k           : std_logic := '0';
  signal rst_i_i           : std_logic := '1';
  signal lcd_data_o_i      : std_logic_vector(7 downto 0);
  signal lcd_rs_o_i        : std_logic;
  signal lcd_rw_o_i        : std_logic;
  signal lcd_e_o_i         : std_logic;

begin  -- test

  DUT: entity work.cpld_lcd
    generic map(G_SIMU_ONLY => true)
    port map (
        clk_i           => clk_32k,
        rst_i           => rst_i_i,
        lcd_data_o      => lcd_data_o_i,
        lcd_rs_o        => lcd_rs_o_i,
        lcd_rw_o        => lcd_rw_o_i,
        lcd_e_o         => lcd_e_o_i);

  clk_div1: entity work.clk_div
    port map (
        clk_i     => clk_i_i,
        rst_i     => rst_i_i,
        clk_32k_o => clk_32k);
  
  clk_i_i <= not clk_I_i after 1 us / 1.8432 ;
  rst_i_i <= '0' after 1 ms ;

end test;
-------------------------------------------------------------------------------


